#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>

/*
UKOLY:
J pridat moznost definovani prazdnych znaku (mezera, tab apod.)
	napriklad tak, ze pro ne nebudou existovat bitmapy
	(pokud to nebude potreba), takze se na sirku cwidth doplni mezerami
	(bwidth=0)
  tak jsem to zkusil a ono to funguje jaksi samo... :-)

*/

// globalni nastaveni
FILE *f;
char bitname[80];
char fontname[80];
char pilrcname[80];
char defname[80];

// struktury z definicniho souboru
int space;
//int fixed;
//int justify;
int ignore;
int width;
int offset;

char line[256];
int glyphs[256];
int glyphcnt;

// struktury pro kopirovani znaku
struct {
  int pos;		// poradi v BMP
  int Boffs;		// pozice znaku v BMP
  int Bwidth;		// sirka bitmapy
  int Coffs;		// posunuti bitmapy ve znaku
  int Cwidth;		// sirka znaku
  int space;		// mezera za znakem
  int parts;		// pocet svislych mezer ve znaku
} Chars[257];	// znaky 0..255, 256 je 'missing'/kod -1

// hlavicka BMP
struct {
  char sig[2];
  unsigned long filesize;
  char dummy[4];
  unsigned long dataoffset;
  unsigned long infolength;
  unsigned long width, height;
  unsigned short planes, bits_pix;
  unsigned long compression;
} BMPheader;
unsigned int *Bitmap;
unsigned int BMProwlen;
unsigned int Bitmask[16]={0x0080, 0x0040, 0x0020, 0x0010, 0x0008, 0x0004, 0x0002, 0x0001,
			  0x8000, 0x4000, 0x2000, 0x1000, 0x0800, 0x0400, 0x0200, 0x0100};
#define	ROW(y) 		((BMPheader.height-y-1)*BMProwlen)
#define	COL(x) 		(x>>4)
#define	COLmask(x)	Bitmask[x&0x000F]
#define	Pixel(x,y)	((~Bitmap[ROW(y)+COL(x)])&COLmask(x))

int ymin, ymax;

// hlavicka fontu
struct {
  unsigned int fontType;
  int firstChar;
  int lastChar;
  unsigned int maxWidth;
  unsigned int kernMax;
  unsigned int nDescent;
  unsigned int fRectWidth;
  unsigned int fRectHeight;
  unsigned int owTLoc;
  unsigned int ascent;
  int descent;
  int leading;
  unsigned int rowWords;
} FontHeader;
unsigned long FontRowLen;
unsigned int Fontmask[16]={0x8000, 0x4000, 0x2000, 0x1000, 0x0800, 0x0400, 0x0200, 0x0100,
			   0x0080, 0x0040, 0x0020, 0x0010, 0x0008, 0x0004, 0x0002, 0x0001};

int strcomp (char *s1, char *s2, char **s3) {
  while (toupper (*s1)==toupper (*s2) && *s1!='\0' && *s2!='\0') s1++, s2++;
  *s3=s1;
  if (!(*(*s3))) *s3=s2;
  while (*(*s3) && *(*s3)==' ') (*s3)++;
  return (*s1=='\0' || *s2=='\0')?0:1;
}

void scans (char *in, char *out) {
  while (*in && (*in==' ' || *in=='"')) in++;
  while (*in && *in!='"') {*out=*in; in++; out++;}
  *out='\0';
}

void scanc (char *in, char *out) {
int val;
  while (*in && *in==' ') in++;
  if (*in=='\'') {in++; *out=*in; return;}
  sscanf (in, "%u", &val);
  *out=(char)val;
  return;
}

// nacteni definicniho souboru a vytvoreni pracovnich struktur
int LoadDef (void) {
int i, j, cnt, mode, lcnt;
char *ptr, *ptr2, tc;
int space_loc, width_loc, offs_loc, parts_loc;
// inicializace promennych
  space=0;
  ignore=3;
//  fixed=0;
  width=0;
  offset=0;
//  justify=0;
  bitname[0]='\0';
  FontHeader.fontType=0x9000;
  FontHeader.firstChar=257;
  FontHeader.lastChar=-1;
  FontHeader.maxWidth=0;
  FontHeader.kernMax=0;
  FontHeader.nDescent=0;
  FontHeader.fRectWidth=0;
  FontHeader.fRectHeight=0;
  FontHeader.owTLoc=0;
  FontHeader.ascent=0;
  FontHeader.descent=-1;
  FontHeader.leading=-1;
  FontHeader.rowWords=0;
  cnt=mode=lcnt=0;
  for (i=0; i<257; i++) {
    Chars[i].pos=Chars[i].Cwidth=-1;
    Chars[i].Coffs=0;
    Chars[i].parts=1;
  }
// prednastaveni lokalnich definic
  space_loc=0;
  width_loc=0;
  offs_loc=0;
  parts_loc=1;
  glyphcnt=0;
// cteni a zpracovani .def souboru
  do {
    if (fgets (line, 256, f)==NULL) {*line='\0'; mode=10;} else {
      lcnt++;
//      for (i=0; line[i]; i++) line[i]=toupper (line[i]);
      for (i=0; line[i] && line[i]<=' '; i++);
      if (!line[i]) continue;
      if (!strcomp (line, "//", &ptr)) continue;
    }
    switch (mode) {
      case 0:
// globalni parametry fontu
	if (!strcomp (line, "FONTTYPE",    &ptr)) {sscanf (ptr, (ptr[1]=='X')?"0X%X":"%u", &FontHeader.fontType); continue;}
	if (!strcomp (line, "FIRSTCHAR",   &ptr)) {sscanf (ptr, "%d", &FontHeader.firstChar); continue;}
	if (!strcomp (line, "LASTCHAR",    &ptr)) {sscanf (ptr, "%d", &FontHeader.lastChar); continue;}
	if (!strcomp (line, "MAXWIDTH",    &ptr)) {sscanf (ptr, "%u", &FontHeader.maxWidth); continue;}
	if (!strcomp (line, "KERNMAX", 	   &ptr)) {sscanf (ptr, "%u", &FontHeader.kernMax); continue;}
	if (!strcomp (line, "NDESCENT",    &ptr)) {sscanf (ptr, "%u", &FontHeader.nDescent); continue;}
	if (!strcomp (line, "FRECTWIDTH",  &ptr)) {sscanf (ptr, "%u", &FontHeader.fRectWidth); continue;}
	if (!strcomp (line, "FRECTHEIGHT", &ptr)) {sscanf (ptr, "%u", &FontHeader.fRectHeight); continue;}
	if (!strcomp (line, "OWTLOC",      &ptr)) {sscanf (ptr, "%u", &FontHeader.owTLoc); continue;}
	if (!strcomp (line, "ASCENT",      &ptr)) {sscanf (ptr, "%d", &FontHeader.ascent); continue;}
	if (!strcomp (line, "DESCENT",     &ptr)) {sscanf (ptr, "%d", &FontHeader.descent); continue;}
	if (!strcomp (line, "LEADING",     &ptr)) {sscanf (ptr, "%d", &FontHeader.leading); continue;}
	if (!strcomp (line, "ROWWORDS",    &ptr)) {sscanf (ptr, "%u", &FontHeader.rowWords); continue;}
	if (!strcomp (line, "SPACE",       &ptr)) {sscanf (ptr, "%u", &space); continue;}
	if (!strcomp (line, "OFFSET",      &ptr)) {sscanf (ptr, "%u", &offset); continue;}
	if (!strcomp (line, "WIDTH",       &ptr)) {sscanf (ptr, "%u", &width); continue;}
	if (!strcomp (line, "IGNORE",      &ptr)) {sscanf (ptr, "%u", &ignore); continue;}
//	if (!strcomp (line, "JUSTIFY",     &ptr)) {sscanf (ptr, "%d", &justify); continue;}
	if (!strcomp (line, "BITMAP",      &ptr)) {scans (ptr, bitname); continue;}
	if (!strcomp (line, "FONT",        &ptr)) {scans (ptr, fontname); continue;}
	if (!strcomp (line, "PILRC",       &ptr)) {scans (ptr, pilrcname); continue;}
	if (strcomp (line, "GLYPH",        &ptr)) {fprintf (stderr, "Unknown word at line %u\n", lcnt); return 1;}
	mode=1;
      case 1:
// zjisteni lokalniho nastaveni
	if (!strcomp (line, "WIDTH", &ptr)) {
	  if (!strcomp (ptr, "AS", &ptr2)) {
	    scanc (ptr2, ptr);
	    width_loc=*ptr;
	    width_loc&=0x00FF;
	    width_loc|=0x2000;
	    if (!offs_loc) offs_loc=0x8000;	// implicitne centruje...
//	  } else
//	  if (!strcomp (ptr, "ADD", &ptr2)) {
//	    sscanf (ptr2, "%d", &width_loc);
//	    width_loc&=0x00FF;
//	    width_loc|=0x1000;
	  } else {
	    sscanf (ptr, "%u", &width_loc);
	  }
	  continue;
	}
	if (!strcomp (line, "SPACE", &ptr)) {sscanf (ptr, "%u", &space_loc); continue;}
	if (!strcomp (line, "OFFSET", &ptr)) {sscanf (ptr, "%d", &offs_loc); continue;}
	if (!strcomp (line, "PARTS", &ptr)) {sscanf (ptr, "%d", &parts_loc); continue;}
	if (!strcomp (line, "GLYPHS", &ptr)) mode=12;
	else
	if (!strcomp (line, "GLYPH", &ptr)) mode=11;
	else {fprintf (stderr, "Unknown word at line %u\n", lcnt); return 1;}
      case 10:
      case 11:
      case 12:
// zpracovani jednotlivych znaku
	i=0;
	if (!offs_loc && (!width_loc || !space_loc)) offs_loc=offset;
	if (!space_loc && (!width_loc || !offs_loc)) space_loc=space;
	if (!width_loc && (!space_loc || !offs_loc)) width_loc=width;
	while (glyphcnt) {
	  j=glyphs[i++];
	  Chars[j].pos=cnt;	// pozice znaku v BMP
	  Chars[j].space=space_loc;
	  Chars[j].Cwidth=width_loc;
	  Chars[j].Coffs=offs_loc;
	  Chars[j].parts=parts_loc;
	  if (j<256) {
	    if (FontHeader.firstChar>j) FontHeader.firstChar=j;
	    if (FontHeader.lastChar<j) FontHeader.lastChar=j;
	  }
	  cnt++;
	  glyphcnt--;
	}
// naplneni bufferu dalsimi znaky
	if (mode==12) {
	  if (*ptr!='"') {fprintf (stderr, "Expecting string at line %u\n", lcnt); return 1;}
	  ptr++;
	  while (*ptr && *ptr!='"') {glyphs[glyphcnt++]=*ptr&0x00FF; ptr++;}
	}
	if (mode==11) {
	  if (*ptr!='\'' && *ptr!='-' && (*ptr<'0' || *ptr>'9')) {fprintf (stderr, "Expecting char or numeral at line %u\n", lcnt); return 1;}
	  if (*ptr=='-') glyphs[0]=256;
	  else {scanc (ptr, &tc); glyphs[0]=tc&0x00FF;}
	  glyphcnt=1;
	}
// nastaveni lokalnich parametru
	space_loc=0;
	width_loc=0;
	offs_loc=0;
	parts_loc=1;
	mode=1;
	break;

    }
  } while (!feof (f));
  return 0;
}

// nacteni bitmapy a vytvoreni struktur pro praci s ni
int LoadBMP (void) {
//FILE *fp;
int x, y;
int flg, parts, cnt, i;
// nacteni hlavicky BMP
  if (fread (&BMPheader, 1, sizeof (BMPheader), f)!=sizeof (BMPheader)) {
    fprintf (stderr, "Error reading BMP\n");
    return 1;
  }
// kontrola formatu BMP
  if (BMPheader.sig[0]!='B' || BMPheader.sig[1]!='M') {
    fprintf (stderr, "Bad signature\n");
    return 1;
  }
  if (BMPheader.planes>1) {
    fprintf (stderr, "Can't convert more than 1 plane\n");
    return 1;
  }
  if (BMPheader.bits_pix>1) {
    fprintf (stderr, "Can't convert more than 1 BPP\n");
    return 1;
  }
  if (BMPheader.compression) {
    fprintf (stderr, "Can't convert compressed BMP\n");
    return 1;
  }
// alokace pameti pro BMP
  BMProwlen=(((BMPheader.width+15)/16)+1)&0xFFFE;
  Bitmap=malloc (BMProwlen*BMPheader.height*2);
  if (Bitmap==NULL) {
    fprintf (stderr, "Can't allocate memory\n");
    return 1;
  }
// nacteni BMP do pameti
  if (fseek (f, BMPheader.dataoffset, SEEK_SET)) {
    fprintf (stderr, "Error reading BMP\n");
    return 1;
  }
  if (fread (Bitmap, 1, BMProwlen*BMPheader.height*2, f)!=BMProwlen*BMPheader.height*2) {
    fprintf (stderr, "Error reading BMP\n");
    return 1;
  }
// kontrolni vystup v textovem rezimu
/*
  fp=fopen ("pokus.fnt", "wt");
  for (y=0; y<BMPheader.height; y++) {
    for (x=0; x<BMPheader.width; x++)
      fputc ((Pixel (x, y))?'#':' ', fp);
    fputc ('\n', fp);
  }
  fclose (fp);
*/
// extrahovani parametru jednotlivych znaku
// podle ignore&1 ignoruji prazdne radky dole
  ymax=BMPheader.height-1;
  if (ignore&1) {
    flg=0;
    do {
      for (x=0; x<BMPheader.width; x++) if (Pixel (x, ymax)) {flg=1; break;}
      if (!flg) ymax--;
    } while (!flg);
  }
  ymax++;
// podle ignore&2 ignoruji prazdne radky nahore
  ymin=0;
  if (ignore&2) {
    flg=0;
    do {
      for (x=0; x<BMPheader.width; x++) if (Pixel (x, ymin)) {flg=1; break;}
      if (!flg) ymin++;
    } while (!flg);
  }
  FontHeader.fRectHeight=ymax-ymin;
// rozdelim BMP na jednotlive znaky
  parts=cnt=flg=0;
  for (x=0; x<BMPheader.width; x++) {
    flg&=0xFFFE;
    for (y=ymin; y<ymax; y++) if (Pixel (x, y)) {flg|=1; break;}
    if (flg&1) {
      if (!(flg&2)) { 	// zacatek bitmapy znaku
	for (i=0; i<257; i++) if (Chars[i].pos==cnt) break;
	Chars[i].Boffs=x;
	parts=Chars[i].parts;
	flg|=4;
      }
      flg|=2;
    } else
    if (flg&2) {
      parts--;
      if (!parts) {
	Chars[i].Bwidth=x-Chars[i].Boffs;
	if (Chars[i].Cwidth==-1) Chars[i].Cwidth=Chars[i].Bwidth;
	cnt++;
	flg&=0xFFFB;
      }
      flg&=0xFFFD;
    }
  }
  if (flg&4) { // uzavreni posledniho znaku
    Chars[i].Bwidth=x-Chars[i].Boffs;
    if (Chars[i].Cwidth==-1) Chars[i].Cwidth=Chars[i].Bwidth;
  }
// kontrola udaju v Chars a zkompletovani automatickych udaju
// prvni pruchod
  i=FontHeader.firstChar;
  cnt=0;
  do {
// pro druhy pruchod potrebuji znat sirku znaku
    if (Chars[i].pos!=-1) {
      if (!Chars[i].Cwidth)
	Chars[i].Cwidth=Chars[i].Coffs+Chars[i].Bwidth+Chars[i].space;
      else
      if ((Chars[i].Cwidth&0xF000)==0x2000)
	cnt++;
    }
    if (i<256 && i>=FontHeader.lastChar) i=256;
    else i++;
  } while (i<257);
// druhy pruchod
  i=FontHeader.firstChar;
  do {
    flg=cnt;
    do {
      if (Chars[i].pos!=-1) {
	if ((Chars[i].Cwidth&0xF000)==0x2000 && !(Chars[Chars[i].Cwidth&0x00FF].Cwidth&0xF000)) {
	  Chars[i].Cwidth=Chars[Chars[i].Cwidth&0x00FF].Cwidth;
	  if ((unsigned)Chars[i].Coffs==0x8000) {
	    Chars[i].Coffs=(Chars[i].Cwidth-Chars[i].Bwidth)/2;
	    Chars[i].space=Chars[i].Cwidth-Chars[i].Bwidth-Chars[i].Coffs;
	  }
	  cnt--;
	}
      }
      if (i<256 && i>=FontHeader.lastChar) i=256;
      else i++;
    } while (i<257);
  } while (cnt && cnt<flg);
  if (cnt) {
    fprintf (stderr, "Cyclic indirection for width parameter\n");
    return 1;
  }
// posledni pruchod
  FontRowLen=0L;
  i=FontHeader.firstChar;
  do {
    if (Chars[i].pos!=-1) {
      x=Chars[i].Coffs+Chars[i].Bwidth+Chars[i].space;
      if (Chars[i].Cwidth<x) {
	Chars[i].Cwidth=x;
	fprintf (stderr, "Character %d width corrected\n", i);
      }
      if (Chars[i].Cwidth>x) {
	if (Chars[i].Coffs) Chars[i].space=Chars[i].Cwidth-Chars[i].Coffs-Chars[i].Bwidth;
	else Chars[i].Coffs=Chars[i].Cwidth-Chars[i].Bwidth-Chars[i].space;
      }
      if (Chars[i].Bwidth>FontHeader.fRectWidth)
	FontHeader.fRectWidth=Chars[i].Bwidth;
      if (Chars[i].Cwidth>FontHeader.maxWidth)
	FontHeader.maxWidth=Chars[i].Cwidth;
      FontRowLen+=Chars[i].Cwidth;	//Bwidth
    }
    if (i<256 && i>=FontHeader.lastChar) i=256;
    else i++;
  } while (i<257);
// jeste upravim fRectWidth kvuli nespravnemu pouzivani fontu v PalmOS
  FontHeader.fRectWidth=FontHeader.maxWidth;
// vypocitam dalsi nastaveni
  FontHeader.rowWords=(FontRowLen+15)/16;
  FontHeader.owTLoc=FontHeader.rowWords*FontHeader.fRectHeight+FontHeader.lastChar-FontHeader.firstChar+8;
// kontrola spravnosti udaju v hlavicce fontu
// ...

  return 0;
}

// vypise info o fontu ve formatu pro PilRC
int SavePilRC (void) {
int i, x, y;

// vypsani hlavicky PilRC
  fprintf (f, "// FontFile generated from %s using %s\n", bitname, defname);
  fprintf (f, "fontType 0x%04X\n", FontHeader.fontType);
  fprintf (f, "firstChar %d\n", FontHeader.firstChar);
  fprintf (f, "lastChar %d\n", FontHeader.lastChar);
  fprintf (f, "maxWidth %u\n", FontHeader.maxWidth);
  fprintf (f, "kernMax %u\n", FontHeader.kernMax);
  fprintf (f, "nDescent %u\n", FontHeader.nDescent);
  fprintf (f, "fRectWidth %u\n", FontHeader.fRectWidth);
  fprintf (f, "fRectHeight %u\n", FontHeader.fRectHeight);
  fprintf (f, "owTLoc %u\n", FontHeader.owTLoc);
  fprintf (f, "ascent %u\n", FontHeader.ascent);
  fprintf (f, "descent %d\n", FontHeader.descent);
  fprintf (f, "leading %d\n", FontHeader.leading);
  fprintf (f, "rowWords %u\n", FontHeader.rowWords);

// vypise bitmapy fontu ve formatu pro PilRC
  for (i=FontHeader.firstChar; i<=256; i++) {
    if (Chars[i].pos!=-1) {
      fprintf (f, "\nGLYPH ");
      if (i>32 && i<127 && (i!=39 && i!=92)) fprintf (f, "'%c'\n", i);
      else fprintf (f, "%d\n", (i==256)?-1:i);
      if (Chars[i].Cwidth!=Chars[i].Bwidth) fprintf (f, "WIDTH %d\n", Chars[i].Cwidth);
      if (Chars[i].Coffs) fprintf (f, "OFFSET %d\n", Chars[i].Coffs);
      for (y=ymin; y<ymax; y++) {
	for (x=0; x<Chars[i].Coffs; x++) fputc ('-', f);
	for (x=Chars[i].Boffs; x<Chars[i].Boffs+Chars[i].Bwidth; x++) {
	  fputc (Pixel (x, y)?'#':'-', f);
	}
	for (x=0; x<Chars[i].space; x++) fputc ('-', f);
	fputc ('\n', f);
      }
    }
    if (i==FontHeader.lastChar) i=255;
  }
  return 0;
}

unsigned long len;
// funkce pro ulozeni Intel int -> Motorola int
void SaveInt (int data) {
  fputc (data>>8, f);
  fputc (data&0x00FF, f);
  len+=2;
//  data=(data<<8)|(data>>8);
//  fwrite (&data, 1, 2, fb);
}

// ulozi font do souboru
int SaveFont (void) {
int x, y, data, i, pos;
  len=0L;
// ulozim hlavicku fontu
  SaveInt (FontHeader.fontType);
  SaveInt (FontHeader.firstChar);
  SaveInt (FontHeader.lastChar);
  SaveInt (FontHeader.maxWidth);
  SaveInt (FontHeader.kernMax);
  SaveInt (FontHeader.nDescent);
  SaveInt (FontHeader.fRectWidth);
  SaveInt (FontHeader.fRectHeight);
  SaveInt (FontHeader.owTLoc);
  SaveInt (FontHeader.ascent);
  SaveInt (FontHeader.descent);
  SaveInt (FontHeader.leading);
  SaveInt (FontHeader.rowWords);
// ulozim bitmapu fontu
  for (y=ymin; y<ymax; y++) {
    data=pos=0;
    for (i=FontHeader.firstChar; i<=256; i++) {
      if (Chars[i].pos!=-1) {
	for (x=0; x<Chars[i].Coffs; x++) {
	  pos++;
	  if (pos>15) {SaveInt (data); pos=data=0;}
	}
	for (x=Chars[i].Boffs; x<Chars[i].Boffs+Chars[i].Bwidth; x++) {
	  if (Pixel (x, y)) data|=Fontmask[pos&0x000F];
	  pos++;
	  if (pos>15) {SaveInt (data); pos=data=0;}
	}
	for (x=0; x<Chars[i].space; x++) {
	  pos++;
	  if (pos>15) {SaveInt (data); pos=data=0;}
	}
      }
      if (i==FontHeader.lastChar) i=255;
    }
    if (pos) SaveInt (data);
  }
// ulozim tabulku offsetu pismen v bitmape
  pos=0;
  for (i=FontHeader.firstChar; i<=FontHeader.lastChar; i++) {
    SaveInt (pos);
    if (Chars[i].pos!=-1)
      pos+=Chars[i].Cwidth;	//Bwidth;
  }
// offset pro 'missing' character
  SaveInt (pos);
  pos+=Chars[256].Cwidth;	//Bwidth;
  SaveInt (pos);
// ulozim tabulku sirky znaku/offsetu bitmapy ve znaku
  for (i=FontHeader.firstChar; i<=FontHeader.lastChar; i++) {
//    SaveInt ((Chars[i].pos==-1)?0xFFFF:(Chars[i].Cwidth));//|(Chars[i].Coffs<<8)));
    SaveInt ((Chars[i].pos==-1)?Chars[256].Cwidth:Chars[i].Cwidth);//|(Chars[i].Coffs<<8)));
  }
//  SaveInt (Chars[256].Cwidth|(Chars[256].Coffs<<8));
  SaveInt (0x0000);
  return 0;
}

void Convert (void) {
int i;

// otvreni definicniho souboru
  if ((f=fopen (defname, "rt"))==NULL) {
    fprintf (stderr, "Can't open DEF file %s\n", defname);
    return;
  }
// zpracovani definicniho souboru
  i=LoadDef ();
  fclose (f);
  if (i) return;

// otevreni souboru bitmapy
  if (!*bitname) {
    fprintf (stderr, "Bitmap filename not specified\n");
    return;
  }
  if ((f=fopen (bitname, "rb"))==NULL) {
    fprintf (stderr, "Can't open BMP file %s\n", bitname);
    return;
  }

// nacteni BMP
  i=LoadBMP ();
  fclose (f);
  if (i) return;

// zapsani souboru font.BIN
  if (*fontname) {
    if ((f=fopen (fontname, "wb"))==NULL) {
      fprintf (stderr, "Can't create FONT file %s\n", fontname);
      return;
    }

// prevod BMP->FNT
    i=SaveFont ();
    fclose (f);
    if (i) return;
    fprintf (stderr, "%s has been written\n", fontname);
  }

// vytvoreni souboru PilRC
  if (*pilrcname) {
    if ((f=fopen (pilrcname, "wt"))==NULL) {
      fprintf (stderr, "Can't create PilRC file %s\n", pilrcname);
      return;
    }

// prevod BMP->PilRC
    i=SavePilRC ();
    fclose (f);
    if (i) return;
    fprintf (stderr, "%s has been written\n", pilrcname);
  }

// konec prevodu
  fprintf (stderr, "All done.\n");
  return;
}

void main (int argc, char *argv[]) {
int i;
char *str;

// inicializace globalnich promennych
  Bitmap=NULL;
  *fontname=*bitname=*pilrcname=*defname='\0';

// banner
  fprintf (stderr, "BMP-to-Font font converter V0.2\n");

// napoveda
  if (argc<2) {
    fprintf (stderr, "BMP2FNT file.DEF [-f<font>.BIN][-p<pilrc>.TXT][-b<bitmap>.BMP]\n");
    return;
  }

// zpracovani prikazove radky
  i=1;
  do {
    if (*argv[i]!='-') strcpy (defname, argv[i]);
    else
    if (!strcomp (argv[i], "-f", &str)) strcpy (fontname, str);
    else
    if (!strcomp (argv[i], "-p", &str)) strcpy (pilrcname, str);
    else
    if (!strcomp (argv[i], "-b", &str)) strcpy (bitname, str);
    else {
      fprintf (stderr, "Unknown parameter '%s'\n", argv[i]);
      return;
    }
    i++;
  } while (i<argc);

  Convert ();
  if (Bitmap!=NULL) free (Bitmap);

  return;
}
